﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace NexusUpdater
{
    public class Logger
    {
        string m_sWorkingFolder = string.Empty;

        static Logger()
        {
            if (Current == null)
                Current = new Logger();

        }

        public static Logger Current
        {
            get;
            set;
        }

        public string WorkingFolder
        {
            get { return m_sWorkingFolder; }
            set 
            { 
                m_sWorkingFolder = value; 
            }
        }

        private Logger()
        {

        }

        public void Write(Exception ex)
        {
            if (ex != null)
            {
                StringBuilder sbMessage = new StringBuilder();
                sbMessage.Append("Exception Msg : ");
                sbMessage.AppendLine(ex.Message);
                sbMessage.AppendLine("Call Stack : ");
                sbMessage.AppendLine(ex.StackTrace);
                if (ex.InnerException != null)
                {
                    sbMessage.Append(" -- Exception Msg : ");
                    sbMessage.AppendLine(ex.Message);
                    sbMessage.AppendLine(" -- Call Stack : ");
                    sbMessage.AppendLine(ex.StackTrace);
                }
                Write("ERROR", sbMessage.ToString());
            }
        }

        public void Write(string sMessage)
        {
            Write("INFO", sMessage);
        }

        public void Write(string sType, List<string> aryLogs)
        {
            StringBuilder sbMessage = new StringBuilder();
            foreach (string sLog in aryLogs)
            {
                sbMessage.AppendLine(sLog);
            }
            Write(sType, sbMessage.ToString());
        }

        public void Write(string sType, string sMessage)
        {
            string sFilename = DateTime.Today.ToString("yyyyMMdd") + ".log";
            string sFullFilename = Path.Combine(m_sWorkingFolder, sFilename);
            StringBuilder sbMessage = new StringBuilder();
            sbMessage.Append(DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss.fff"));
            sbMessage.Append("  /  ");
            sbMessage.AppendLine(sType);
            sbMessage.AppendLine(sMessage);

            try
            {
                using (StreamWriter writer = new StreamWriter(File.Open(sFilename, FileMode.OpenOrCreate)))
                {
                    writer.WriteLine(sbMessage.ToString());
                }
            }
            catch
            {
            }
        }
    }
}
